;##################################################################
; DIALOGAPP
;##################################################################

#include "OwnerDrawBtn.h"

.CONST
	IDD_DLG1			equ					1000
.DATA
	hInstance	DD 	?
	hIml		DD	?
	icc			DQ	3FFF00000008h

.CODE

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax

	invoke InitCommonControlsEx,OFFSET icc
	; Create an image list from the button strip and set the transparent color
	invoke ImageList_LoadImage,[hInstance],5000,21,40,0ffffffh,\
			IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hIml],eax
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	; destroy the image list
	invoke ImageList_Destroy,[hIml]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi

	.WM_INITDIALOG
	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_DRAWITEM
		invoke GetDlgItem,[hwnd],1002
		invoke EnableWindow,eax,FALSE
		jmp >>.EXIT

	.WM_DRAWITEM
	cmp D[uMsg],WM_DRAWITEM
	jne >>.WM_COMMAND
	WMDRAWITEM:
		; Check to see if the button falls in the range of our buttons
		; This is just to show how to do it, it is not really necessary
		; here but if you have other OD controls you will have to filter
		cmp W[wParam],1001
		jl >>.DEFPROC
		cmp W[wParam],1007
		jg >>.DEFPROC
			mov edi,[lParam]	;DRAWITEMSTRUCT
			; Create a backbuffer
			invoke CreateCompatibleDC,[edi+DRAWITEMSTRUCT.hdc]
			mov ebx,eax ; EBX is DC
			invoke CreateCompatibleBitmap,[edi+DRAWITEMSTRUCT.hdc],24,24
			invoke SelectObject,ebx,eax
			mov esi,eax ; ESI is the old object we don't need to save hBmp

			; Erase the background using the buttonface color
			invoke GetSysColor,COLOR_BTNFACE
			invoke CreateSolidBrush,eax
			push eax
			mov ecx,edi
			add ecx,DRAWITEMSTRUCT.rcItem
			invoke FillRect,ebx,ecx,eax
			pop eax
			invoke DeleteObject,eax

			; Get the image index
			movzx ecx,W[wParam]
			sub ecx,1001
			shl ecx,2

			mov eax,[edi+DRAWITEMSTRUCT.itemState]
			; Check to see if the button is disabled
			test eax,ODS_DISABLED
			jz >
				; Add 2 for the disabled image
				add ecx,2
				jmp >.DRAWIT
			:
			; Check to see if the button is pressed or not
			test eax,ODS_SELECTED
			jz >.DRAWIT
				inc ecx ; Add one to the image index for the down state
			.DRAWIT
				invoke ImageList_Draw,[hIml],ecx,ebx,0,0,ILD_TRANSPARENT
				invoke BitBlt,[edi+DRAWITEMSTRUCT.hdc],0,0,24,24,ebx,0,0,SRCCOPY
				invoke SelectObject,ebx,esi
				invoke DeleteObject,eax
				invoke DeleteDC,ebx
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TRUE
				xor eax,eax
				inc eax
				ret

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF
